#include <sys/socket.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <cerrno>

#include "servertask.hh"
#include "taskmanager.hh"
#include "playertask.hh"

servertask::servertask(int Port)
{
    if((Plug = socket(AF_INET, SOCK_STREAM, 0)) < 0)
        _exit(EXIT_FAILURE);

ReBind:
    MyAddr.sin_port = htons(Port);              /* network order */
    MyAddr.sin_family = AF_INET;                /* host byte order */
    MyAddr.sin_addr.s_addr = htonl(INADDR_ANY); /* auto-fill with my IP, network long  */
    memset((void *)&(MyAddr.sin_zero), 0, 8);   /* zero the rest of the struct */

    if(bind(Plug, (struct sockaddr *)&MyAddr, sizeof(struct sockaddr)))
    {
        if(errno == EADDRINUSE) /* Address already in use */
        {
        	cout << "Bind failed... retrying.\n";
            sleep(1);
            goto ReBind;
        }
        _exit(EXIT_FAILURE);
    }

    /* Plug will listen. Number of max waiting connections = 10 */

    if(listen(Plug, 10) < 0)
        _exit(EXIT_FAILURE);

    /* Prepare this for accept() - not modified inside the loop */
    AddrLen = sizeof(They);
    
    fcntl(Plug, F_SETFL, fcntl(Plug, F_GETFL) | O_NONBLOCK);
    
    cout << "Listening for connections on port " << Port << ".\n";
}

bool servertask::tick()
{
    int Sock = accept(Plug, (struct sockaddr *)&They, &AddrLen);
    
    if(Sock >= 0)
    {
        fcntl(Sock, F_SETFL, fcntl(Sock, F_GETFL) | O_NONBLOCK);
        taskmanager.insert(new playertask(Sock));
    }
    
    return true;
}
